/******
 * const defination
 * @prefix REG_ defines regular expressions const
 * @prefix TAG_ defines variables which used in the internal program  
 */

var BROWSER_FIREFOX =  /firefox/.test(navigator.userAgent.toLowerCase());
var BROWSER_SAFARI =  /safari/.test(navigator.userAgent.toLowerCase());
var BROWSER_IE =  /mozilla/.test(navigator.userAgent.toLowerCase()) && !BROWSER_FIREFOX;
var BROWSER_CHROME =  /chrome/.test(navigator.userAgent.toLowerCase()) && !BROWSER_FIREFOX;

(function($){
	var methods = {
		/**
		 * display dom or not 
		 */
		display : function(a) {
			if(typeof a == 'undefined') a == 'block';
			this.css('display', a);
		},
		visible : function(bool) {
			this.css('visibility', bool ? 'visible' : 'hidden');
		},
		//set or get img property src
		src : function(src) {
			if(typeof src === 'undefined') return this.attr('src');
			if(src == TAG_DEFAULT) this.attr('src', IMG_DEFAULT);
			else this.attr('src', src);
		},
		//find the property of the node which specified by prefix 'data-'
		key : function(key, val) {
			if(typeof val === 'undefined') {
				return this.attr('data-' + key);
			} else {
				this.attr('data-' + key, val);
			}
		},
		disabled : function(b) {
			b = typeof b == 'undefined' ? true : false;
			if(b) {
				this.attr('disabled', true);
			} else {
				this.removeAttr('disabled');
			}
		},
		waiting : function(type) {
			if(type == 'button') {
				this.html('<i class="fa fa-spin fa-spinner"></i> 请稍等..</span>');
				this.disabled();
			} else {
				this.addClass('fa-spin');
				this.addClass('fa-spinner');
			}
		},
		loading : function(text) {
			if(typeof text != 'undefined') {
				this.html(text);
				this.disabled(false);
			} else {
				this.html('<i class="fa fa-spin fa-spinner"></i> 请稍等..</span>');
				this.disabled();
				
			}
		},
		matched : function() {
			this.removeClass('fa-spin');
			this.removeClass('fa-spinner');
		},
		move : function(direction, distance) {
			if('top' == direction) {
				this.css('transform', 'translate(0, ' + distance + ')');
				this.css('-webkit-transform', 'translate(0, ' + distance + ')');
			}else if('left' == direction) {
				this.css('transform', 'translate(' + distance + ', 0)');
				this.css('-webkit-transform', 'translate(' + distance + ', 0)');
			} else {
				this.css('transform', 'translate(' + distance + ', 0)');
				this.css('-webkit-transform', 'translate(' + distance + ', 0)');
			}
			
		},
	};
	$.fn.extend(methods);
	/**
	 * find the position of the array which specified by parameter val
 	 * @param {Object} val
	 */

	/**
	 * if the string is empty 
	 */
	String.prototype.empty = function() {
		if(this == '' || this == undefined || this == 'undefined' || !this) return true;
		return false;
	};
	String.prototype.format = function(data) {
		var fmt = this;
			for(var i = 0; i < data.length; i++){
				var reg = new RegExp('%' + i, 'g'),
				//var reg = '%' + i;
					//str = String(data[i]).replace(/%/g, '\\%\\');
				fmt = fmt.replace(reg, data[i]);
			}
		return fmt;
		//return fmt.replace(/\\%\\/g, '%');
	};
})(jQuery);

/**
 * execute function atfer a while, if not specified,
 * delay ususlly being 1500 
 * 
 * @param {function} fn Must be specified
 * @param {int} delay
 */
function later(fn, delay) {
	if(typeof delay === 'undefined') delay = 1500;
	setTimeout(fn, delay);
}
function ready(action) {
	$(document).ready(action);
}